Index: NEMO/trunk/src/ICE/icedyn_adv_umx.F90
===================================================================
--- NEMO/trunk/src/ICE/icedyn_adv_umx.F90	(revision 10404)
+++ NEMO/trunk/src/ICE/icedyn_adv_umx.F90	(revision 10413)
@@ -14,5 +14,5 @@
    !!   ultimate_x(_y)    : compute a tracer value at velocity points using ULTIMATE scheme at various orders
    !!   macho             : ???
-   !!   nonosc_2d         : compute monotonic tracer fluxes by a non-oscillatory algorithm 
+   !!   nonosc            : compute monotonic tracer fluxes by a non-oscillatory algorithm 
    !!----------------------------------------------------------------------
    USE phycst         ! physical constant
@@ -20,4 +20,5 @@
    USE sbc_oce , ONLY : nn_fsbc   ! update frequency of surface boundary condition
    USE ice            ! sea-ice variables
+   USE icevar         ! sea-ice: operations
    !
    USE in_out_manager ! I/O manager
@@ -34,4 +35,52 @@
    REAL(wp) ::   z1_120 = 1._wp / 120._wp   ! =1/120
 
+   REAL(wp), DIMENSION(:,:), ALLOCATABLE :: z1_ai, amaxu, amaxv
+   
+   LOGICAL ll_dens
+
+   ! advect H all the way (and get V=H*A at the end)
+   LOGICAL :: ll_thickness = .FALSE.
+   
+   ! look for 9 points around in nonosc limiter  
+   LOGICAL :: ll_9points = .FALSE.  ! false=better h?
+
+   ! use HgradU in nonosc limiter  
+   LOGICAL :: ll_HgradU = .TRUE.   ! no effect?
+
+   ! if T interpolated at u/v points is negative, then interpolate T at u/v points using the upstream scheme
+   LOGICAL :: ll_neg = .TRUE.      ! keep TRUE
+   
+   ! limit the fluxes
+   LOGICAL :: ll_zeroup1 = .FALSE. ! false ok if Hbig otherwise needed for 2D sinon on a des valeurs de H trop fortes !!
+   LOGICAL :: ll_zeroup2 = .FALSE. ! false ok for 1D, 2D, 3D
+   LOGICAL :: ll_zeroup4 = .FALSE. ! false ok for 1D, 2D, 3D
+   LOGICAL :: ll_zeroup5 = .FALSE. ! false ok for 1D, 2D
+
+   ! fluxes that are limited are u*H, then (u*H)*(ua/u) is used for V (only for nonosc)
+   LOGICAL :: ll_clem   = .TRUE.   ! simpler than rachid and works
+
+   ! First advect H as H*=Hdiv(u), then use H* for H(n+1)=H(n)-div(uH*)
+   LOGICAL :: ll_gurvan = .FALSE.  ! must be false for 1D case !!
+
+   ! First guess as div(uH) (-true-) or Hdiv(u)+ugradH (-false-)
+   LOGICAL :: ll_1stguess_clem = .FALSE. ! better negative values but less good h
+
+   ! advect (or not) open water. If not, retrieve it from advection of A
+   LOGICAL :: ll_ADVopw = .FALSE.  !
+   
+   ! alternate directions for upstream
+   LOGICAL :: ll_upsxy = .TRUE.
+
+   ! alternate directions for high order
+   LOGICAL :: ll_hoxy = .TRUE.
+   
+   ! prelimiter: use it to avoid overshoot in H
+   LOGICAL :: ll_prelimiter_zalesak = .TRUE.  ! from: Zalesak(1979) eq. 14 => true is better for 1D but false is better in 3D (for h and negative values) => pb in x-y?
+   LOGICAL :: ll_prelimiter_devore  = .FALSE.  ! from: Devore eq. 11 (worth than zalesak)
+
+   ! iterate on the limiter (only nonosc)
+   LOGICAL :: ll_limiter_it2 = .FALSE.
+   
+
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
@@ -39,10 +88,10 @@
    !! NEMO/ICE 4.0 , NEMO Consortium (2018)
    !! $Id$
-   !! Software governed by the CeCILL license (see ./LICENSE)
+   !! Software governed by the CeCILL licence     (./LICENSE)
    !!----------------------------------------------------------------------
 CONTAINS
 
-   SUBROUTINE ice_dyn_adv_umx( k_order, kt, pu_ice, pv_ice,  &
-      &                    pato_i, pv_i, pv_s, psv_i, poa_i, pa_i, pa_ip, pv_ip, pe_s, pe_i )
+   SUBROUTINE ice_dyn_adv_umx( kn_umx, kt, pu_ice, pv_ice,  &
+      &                        pato_i, pv_i, pv_s, psv_i, poa_i, pa_i, pa_ip, pv_ip, pe_s, pe_i )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE ice_dyn_adv_umx  ***
@@ -54,5 +103,5 @@
       !! Reference : Leonard, B.P., 1991, Comput. Methods Appl. Mech. Eng., 88, 17-74. 
       !!----------------------------------------------------------------------
-      INTEGER                     , INTENT(in   ) ::   k_order    ! order of the scheme (1-5 or 20)
+      INTEGER                     , INTENT(in   ) ::   kn_umx     ! order of the scheme (1-5=UM or 20=CEN2)
       INTEGER                     , INTENT(in   ) ::   kt         ! time step
       REAL(wp), DIMENSION(:,:)    , INTENT(in   ) ::   pu_ice     ! ice i-velocity
@@ -70,12 +119,14 @@
       !
       INTEGER  ::   ji, jj, jk, jl, jt      ! dummy loop indices
-      INTEGER  ::   initad                  ! number of sub-timestep for the advection
-      REAL(wp) ::   zcfl , zusnit, zdt      !   -      -
-      REAL(wp), ALLOCATABLE, DIMENSION(:,:) ::   zudy, zvdx, zcu_box, zcv_box
+      INTEGER  ::   icycle                  ! number of sub-timestep for the advection
+      REAL(wp) ::   zamsk                   ! 1 if advection of concentration, 0 if advection of other tracers
+      REAL(wp) ::   zcfl , zdt
+      REAL(wp), DIMENSION(jpi,jpj) ::   zudy, zvdx, zcu_box, zcv_box, zua_ho, zva_ho
+      REAL(wp), DIMENSION(jpi,jpj) ::   zhvar
+      REAL(wp), DIMENSION(jpi,jpj) ::   zai_b, zai_a, z1_ai_b
       !!----------------------------------------------------------------------
       !
       IF( kt == nit000 .AND. lwp )   WRITE(numout,*) '-- ice_dyn_adv_umx: Ultimate-Macho advection scheme'
       !
-      ALLOCATE( zudy(jpi,jpj) , zvdx(jpi,jpj) , zcu_box(jpi,jpj) , zcv_box(jpi,jpj) )
       !
       ! --- If ice drift field is too fast, use an appropriate time step for advection (CFL test for stability) --- !        
@@ -84,9 +135,9 @@
       IF( lk_mpp )   CALL mpp_max( zcfl )
 
-      IF( zcfl > 0.5 ) THEN   ;   initad = 2   ;   zusnit = 0.5_wp
-      ELSE                    ;   initad = 1   ;   zusnit = 1.0_wp
-      ENDIF
-
-      zdt = rdt_ice / REAL(initad)
+      IF( zcfl > 0.5 ) THEN   ;   icycle = 2 
+      ELSE                    ;   icycle = 1 
+      ENDIF
+      
+      zdt = rdt_ice / REAL(icycle)
 
       ! --- transport --- !
@@ -109,34 +160,117 @@
       END DO
 
+      IF(.NOT. ALLOCATED(z1_ai))       ALLOCATE(z1_ai(jpi,jpj))
+      IF( ll_zeroup2 ) THEN
+         IF(.NOT. ALLOCATED(amaxu))       ALLOCATE(amaxu (jpi,jpj))
+         IF(.NOT. ALLOCATED(amaxv))       ALLOCATE(amaxv (jpi,jpj))
+      ENDIF
       !---------------!
       !== advection ==!
       !---------------!
-      DO jt = 1, initad
-         CALL adv_umx( k_order, kt, zdt, zudy, zvdx, zcu_box, zcv_box, pato_i(:,:) )             ! Open water area 
+      DO jt = 1, icycle
+
+         IF( ll_ADVopw ) THEN
+            ll_dens=.FALSE.
+            zamsk = 1._wp
+            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zudy, zvdx, zcu_box, zcv_box, pato_i(:,:), pato_i(:,:) )   ! Open water area 
+         ELSE
+            zai_b(:,:) = SUM( pa_i(:,:,:), dim=3 )
+         ENDIF
+         
          DO jl = 1, jpl
-            CALL adv_umx( k_order, kt, zdt, zudy, zvdx, zcu_box, zcv_box, pa_i(:,:,jl) )         ! Ice area
-            CALL adv_umx( k_order, kt, zdt, zudy, zvdx, zcu_box, zcv_box, pv_i(:,:,jl) )         ! Ice  volume
-            CALL adv_umx( k_order, kt, zdt, zudy, zvdx, zcu_box, zcv_box, psv_i(:,:,jl) )        ! Salt content
-            CALL adv_umx( k_order, kt, zdt, zudy, zvdx, zcu_box, zcv_box, poa_i(:,:,jl) )        ! Age content
+            !
+            WHERE( pa_i(:,:,jl) >= epsi20 )   ;   z1_ai_b(:,:) = 1._wp / pa_i(:,:,jl)
+            ELSEWHERE                         ;   z1_ai_b(:,:) = 0.
+            END WHERE
+            !
+            IF( ll_zeroup2 ) THEN
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1
+                     amaxu(ji,jj)=MAX( pa_i(ji,jj,jl), pa_i(ji,jj-1,jl), pa_i(ji,jj+1,jl), &
+                        &                              pa_i(ji+1,jj,jl), pa_i(ji+1,jj-1,jl), pa_i(ji+1,jj+1,jl) )
+                     amaxv(ji,jj)=MAX( pa_i(ji,jj,jl), pa_i(ji-1,jj,jl), pa_i(ji+1,jj,jl), &
+                        &                              pa_i(ji,jj+1,jl), pa_i(ji-1,jj+1,jl), pa_i(ji+1,jj+1,jl) )
+                 END DO
+               END DO
+               CALL lbc_lnk_multi(amaxu, 'T', 1., amaxv, 'T', 1.)
+            ENDIF
+            !
+            zamsk = 1._wp
+            ll_dens=.TRUE.
+            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zudy, zvdx, zcu_box, zcv_box, pa_i(:,:,jl), pa_i(:,:,jl), zua_ho, zva_ho ) ! Ice area
+            ll_dens=.FALSE.
+
+            WHERE( pa_i(:,:,jl) >= epsi20 )   ;   z1_ai(:,:) = 1._wp / pa_i(:,:,jl)
+            ELSEWHERE                         ;   z1_ai(:,:) = 0.
+            END WHERE              
+
+            IF( ll_thickness ) THEN
+               zua_ho(:,:) = zudy(:,:)
+               zva_ho(:,:) = zvdx(:,:)
+            ENDIF
+            
+            zamsk = 0._wp ; zhvar(:,:) = pv_i (:,:,jl) * z1_ai_b(:,:)
+            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar(:,:), pv_i (:,:,jl) )              ! Ice volume
+            IF( ll_thickness )   pv_i(:,:,jl) = zhvar(:,:) * pa_i(:,:,jl)
+            
+            zamsk = 0._wp ; zhvar(:,:) = pv_s (:,:,jl) * z1_ai_b(:,:)
+            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar(:,:), pv_s (:,:,jl) )              ! Snw volume
+            IF( ll_thickness )   pv_s(:,:,jl) = zhvar(:,:) * pa_i(:,:,jl)
+
+            zamsk = 0._wp ; zhvar(:,:) = psv_i(:,:,jl) * z1_ai_b(:,:)
+            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar(:,:), psv_i(:,:,jl) )              ! Salt content
+
+            zamsk = 0._wp ; zhvar(:,:) = poa_i(:,:,jl) * z1_ai_b(:,:)
+            CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar(:,:), poa_i(:,:,jl) )              ! Age content
+
             DO jk = 1, nlay_i
-               CALL adv_umx( k_order, kt, zdt, zudy, zvdx, zcu_box, zcv_box, pe_i(:,:,jk,jl) )   ! Ice  heat content
-            END DO
-            CALL adv_umx( k_order, kt, zdt, zudy, zvdx, zcu_box, zcv_box, pv_s(:,:,jl) )         ! Snow volume
+               zamsk = 0._wp ; zhvar(:,:) = pe_i(:,:,jk,jl) * z1_ai_b(:,:)
+               CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho, zva_ho, zcu_box, zcv_box, zhvar(:,:), pe_i(:,:,jk,jl) )           ! Ice heat content
+            END DO
+
             DO jk = 1, nlay_s
-               CALL adv_umx( k_order, kt, zdt, zudy, zvdx, zcu_box, zcv_box, pe_s(:,:,jk,jl) )   ! Snow heat content
-            END DO
-            IF ( ln_pnd_H12 ) THEN
-               CALL adv_umx( k_order, kt, zdt, zudy, zvdx, zcu_box, zcv_box, pa_ip(:,:,jl) )     ! Melt pond fraction
-               CALL adv_umx( k_order, kt, zdt, zudy, zvdx, zcu_box, zcv_box, pv_ip(:,:,jl) )     ! Melt pond volume
-            ENDIF
-         END DO
-      END DO
-      !
-      DEALLOCATE( zudy, zvdx, zcu_box, zcv_box )
+               zamsk = 0._wp ; zhvar(:,:) = pe_s(:,:,jk,jl) * z1_ai_b(:,:)
+               CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho, zva_ho, zcu_box, zcv_box, zhvar(:,:), pe_s(:,:,jk,jl) )           ! Snw heat content
+            END DO
+            !
+            IF ( ln_pnd_H12 ) THEN   ! melt ponds (must be the last ones to be advected because of z1_ai_b...)
+               !
+               WHERE( pa_ip(:,:,jl) >= epsi20 )   ;   z1_ai_b(:,:) = 1._wp / pa_ip(:,:,jl)
+               ELSEWHERE                          ;   z1_ai_b(:,:) = 0.
+               END WHERE
+               !
+               zamsk = 1._wp
+               ll_dens=.TRUE.
+               CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zudy, zvdx, zcu_box, zcv_box, pa_ip(:,:,jl), pa_ip(:,:,jl), zua_ho, zva_ho ) ! mp fractio!n
+               ll_dens=.FALSE.
+
+               WHERE( pa_ip(:,:,jl) >= epsi20 )   ;   z1_ai(:,:) = 1._wp / pa_ip(:,:,jl)
+               ELSEWHERE                          ;   z1_ai(:,:) = 0.
+               END WHERE              
+
+               zamsk = 0._wp ; zhvar(:,:) = pv_ip(:,:,jl) * z1_ai_b(:,:)
+               CALL adv_umx( zamsk, kn_umx, jt, kt, zdt, zudy, zvdx, zua_ho , zva_ho , zcu_box, zcv_box, zhvar(:,:), pv_ip(:,:,jl) )              ! mp volume
+            ENDIF
+            !
+            !
+         END DO
+
+         IF( .NOT. ll_ADVopw ) THEN
+            zai_a(:,:) = SUM( pa_i(:,:,:), dim=3 )
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1
+                  pato_i(ji,jj) = pato_i(ji,jj) - ( zai_a(ji,jj) - zai_b(ji,jj) ) &
+                     &                          - ( zudy(ji,jj) - zudy(ji-1,jj) + zvdx(ji,jj) - zvdx(ji,jj-1) ) * r1_e1e2t(ji,jj) * zdt
+               END DO
+            END DO
+            CALL lbc_lnk( pato_i(:,:), 'T',  1. )
+         ENDIF
+         
+      END DO
       !
    END SUBROUTINE ice_dyn_adv_umx
 
    
-   SUBROUTINE adv_umx( k_order, kt, pdt, puc, pvc, pubox, pvbox, ptc )
+   SUBROUTINE adv_umx( pamsk, kn_umx, jt, kt, pdt, pu, pv, puc, pvc, pubox, pvbox, pt, ptc, pua_ho, pva_ho )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE adv_umx  ***
